/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.arrebol.apc.web.beans.admin;

import com.arrebol.apc.controller.GenericController;
import com.arrebol.apc.controller.admin.StatsZeroPaymentsController;
import com.arrebol.apc.model.core.User;
import com.arrebol.apc.model.views.StatsZeroPaymentsView;
import com.arrebol.apc.web.beans.Datatable;
import com.arrebol.apc.web.beans.GenericBean;
import java.io.Serializable;
import java.util.Calendar;
import java.util.List;
import javax.annotation.PostConstruct;
import javax.faces.application.FacesMessage;
import javax.faces.view.ViewScoped;
import javax.inject.Named;
import org.primefaces.event.ReorderEvent;
import org.primefaces.event.RowEditEvent;

/**
 *
 * @author David Rodriguez
 */
@Named("statsZeroPaymentsManager")
@ViewScoped
public class StatsZeroPaymentsBean extends GenericBean implements Serializable, Datatable {

    public void searchHistoricalAction() {
        try {
            if (getStarDate().after(getEndDate())) {
                showMessage(FacesMessage.SEVERITY_ERROR, getBundlePropertyFile().getString("generic.start.date"), getBundlePropertyFile().getString("generic.end.date.error"));
            } else {
                setZeroPayments(fillDatatableZeroPayments());
                setTotalValue();
            }
        } catch (Exception e) {
        }
    }

    public int searchTotalZeroPaymentsAction() {
        try {
            if (getStarDate().after(getEndDate())) {
                showMessage(FacesMessage.SEVERITY_ERROR, getBundlePropertyFile().getString("generic.start.date"), getBundlePropertyFile().getString("generic.end.date.error"));
            } else {
                setTotalValue();
            }
        } catch (Exception e) {
        }
        return getTotalZeroPayments();
    }

    public StatsZeroPaymentsController getZeroPaymentsCtrl() {
        return zeroPaymentsCtrl;
    }

    public void setZeroPaymentsCtrl(StatsZeroPaymentsController zeroPaymentsCtrl) {
        this.zeroPaymentsCtrl = zeroPaymentsCtrl;
    }

    public GenericController getGenericCtrl() {
        return genericCtrl;
    }

    public void setGenericCtrl(GenericController genericCtrl) {
        this.genericCtrl = genericCtrl;
    }

    public List<StatsZeroPaymentsView> fillDatatableZeroPayments() {
        return getZeroPaymentsCtrl().fillZeroPaymentsDataTable(getStarDate(), getEndDate(), getUserSelectedId());
    }

    public int fillTotalZeroPayments() {
        return getZeroPaymentsCtrl().fillTotalZeroPayments(getStarDate(), getEndDate());
    }

    public List<StatsZeroPaymentsView> getZeroPayments() {
        return zeroPayments;
    }

    public void setZeroPayments(List<StatsZeroPaymentsView> zeroPayments) {
        this.zeroPayments = zeroPayments;
    }

    public StatsZeroPaymentsView getSelectedZeroPayments() {
        return selectedZeroPayments;
    }

    public void setSelectedZeroPayments(StatsZeroPaymentsView selectedZeroPayments) {
        this.selectedZeroPayments = selectedZeroPayments;
    }

    public int getTotalZeroPayments() {
        return totalZeroPayments;
    }

    public void setTotalZeroPayments(int totalZeroPayments) {
        this.totalZeroPayments = totalZeroPayments;
    }

    public List<User> getUsers() {
        return genericCtrl.getAllUsersByOffice(getLoggedUser().getOffice().getId());
    }
    
    public String getUserSelectedId() {
        return userSelectedId;
    }

    public void setUserSelectedId(String userSelectedId) {
        this.userSelectedId = userSelectedId;
    }
    
    private StatsZeroPaymentsController zeroPaymentsCtrl;
    private GenericController genericCtrl;
    private List<StatsZeroPaymentsView> zeroPayments;
    private StatsZeroPaymentsView selectedZeroPayments;
    private int totalZeroPayments;
    private List<User> users;
    private String userSelectedId;

    @PostConstruct
    public void init() {
        loadBundlePropertyFile();
        initStartAndEndDates(Calendar.DAY_OF_WEEK, 2);

        zeroPaymentsCtrl = new StatsZeroPaymentsController();
        genericCtrl = new GenericController();
        zeroPayments = fillDatatableZeroPayments();
        setTotalValue();
        users = getUsers();
    }

    @Override
    public void editRow(RowEditEvent event) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public void onRowCancel(RowEditEvent event) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public void onRowReorder(ReorderEvent event) {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public void addRow() {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }

    @Override
    public void deleteRow() {
        throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
    }
    
    private void setTotalValue() {
        if (zeroPayments != null) {
            setTotalZeroPayments(zeroPayments.size());
        } else {
            setTotalZeroPayments(0);
        }
    }
}
